<HTML>

<HEAD></HEAD>

<BODY>
    <script type="text/javascript">
        var Times = [];
        var count=0;
        var str='';
        
        function getPromise(i) {
            return new Promise((resolve) => {setTimeout(() => {resolve(i)}, Times[i]);});
        }

        function goAhead() {
            var pro=getPromise(count);
            pro.then(data => {
                str += 'Resolved N ' + data + ' after timeOut=' + Times[data] + '<BR>';
                document.getElementById('outPut').innerHTML = str;
                count++;
                if (count<Times.length){goAhead();}
            });
        return
        }

    </script>
    Timeout for delay:<input type='text' size='10' value='3000' id='timeOut'>
    <input type='button' value='Add to array' id='addTime' onClick='Times.push(parseInt(document.getElementById("timeOut").value))'>
    <input type='button' value='Resolve array' id='resolve' onClick='goAhead()'>
    <input type='button' value='Create generator' id='generator' onClick='generate()'>
    <div id='outPut'></div>
</BODY>

</HTML>
